#include "main.h"
#include "spi.h"
#include "w25qxx.h"
/**
  * @brief SPI1 读一个字节
  * @param None
  * @retval None
  */
static uint8_t spi1_flash_read_byte(void)
{
    uint8_t t_data, r_data;

    if(HAL_SPI_TransmitReceive(&hspi1, &t_data, &r_data, 1, 0xFFFFFF) != HAL_OK)
    {
        r_data = 0xff;
    }
    return r_data;
}
/**
  * @brief SPI1 写一个字节
  * @param byte 写入的字节
  * @retval 写状态 0成功 1失败
  */
static uint8_t spi1_flash_send_byte(uint8_t byte)
{
    uint8_t r_data;

    if(HAL_SPI_TransmitReceive(&hspi1, &byte, &r_data, 1, 0xFFFFFF) != HAL_OK)
    {
        return 1;
    }
    return 0;
}
/**
  * @brief FLASH 写使能
  * @param None
  * @retval None
  */
static void spi1_flash_write_enable(void)
{
    SPI_FLASH_CS_LOW();/* 通讯开始：CS低 */
    spi1_flash_send_byte(W25X_WriteEnable); /* 发送写使能命令*/
    SPI_FLASH_CS_HIGH();/*通讯结束：CS高 */
}
/**
  * @brief FLASH 等待写结束
  * @param None
  * @retval None
  */
void spi1_flash_wait_for_write_end(void)
{
    uint8_t state = 0;

    SPI_FLASH_CS_LOW();/* 选择 FLASH: CS 低 */

    spi1_flash_send_byte(W25X_ReadStatusReg); /* 发送 读状态寄存器 命令 */
/* 若FLASH忙碌，则等待 */
    do
    {/* 读取FLASH芯片的状态寄存器 */
        state = spi1_flash_read_byte();
    }
    while((state & 0x01) == SET);/* 正在写入标志 */

    SPI_FLASH_CS_HIGH(); /* 停止信号  FLASH: CS 高 */
}
/**
  * @brief FLASH 读ID
  * @param None
  * @retval None
  */
uint32_t spi_flash_read_ID(void)
{
    uint32_t temp, temp0, temp1, temp2;

    SPI_FLASH_CS_LOW();/* 开始通讯：CS低电平 */
    spi1_flash_send_byte(W25X_JedecDeviceID);/* 发送JEDEC指令，读取ID */

    temp0 = spi1_flash_read_byte();
    temp1 = spi1_flash_read_byte();
    temp2 = spi1_flash_read_byte();

    SPI_FLASH_CS_HIGH();/* 停止通讯：CS高电平 */

    temp = (temp0 << 16) | (temp1 << 8) | temp2;

    return temp;
}
/**
  * @brief 读FLASH
  * @param addr 读flash的起始地址
  * @param pdata 读到的数据存放起始地址
  * pdata size 读数据大小
  * @retval None
  */
void spi1_flash_read(uint32_t addr,uint8_t *pdata, uint16_t size)
{
    SPI_FLASH_CS_LOW();

    spi1_flash_send_byte(W25X_ReadData);

    spi1_flash_send_byte((addr & 0xFF0000) >> 16);
    spi1_flash_send_byte((addr & 0xFF00) >> 8);
    spi1_flash_send_byte(addr  & 0xFF);

    while (size--)
    {
        *pdata = spi1_flash_read_byte();
        pdata++;
    }

    SPI_FLASH_CS_HIGH();
}
/**
  * @brief 按页写FLASH
  * @param addr 写入flash的起始地址
  * @param pdata 写入数据的起始地址
  * pdata size 写数据大小
  * @retval None
  */
void spi1_flash_page_write(uint32_t addr, uint8_t *pdata, uint16_t size)
{
    uint16_t i;

    spi1_flash_write_enable();/* 发送FLASH写使能命令 */

    SPI_FLASH_CS_LOW();/* 选择FLASH: CS低电平 */

    spi1_flash_send_byte(W25X_PageProgram);/* 写送写指令*/
    spi1_flash_send_byte((uint8_t)((addr)>>16));
    spi1_flash_send_byte((uint8_t)((addr)>>8));
    spi1_flash_send_byte((uint8_t)addr);

    for(i = 0; i < size; i++)
    {
        spi1_flash_send_byte(pdata[i]);
    }

    SPI_FLASH_CS_HIGH();/* 停止信号 FLASH: CS 高电平 */
    spi1_flash_wait_for_write_end();/* 等待写入完毕*/
}
/**
  * @brief 写FLASH
  * @param addr 写入flash的起始地址
  * @param pdata 写入数据的起始地址
  * pdata size 写数据大小
  * @retval None
  */
void spi1_flash_write(uint32_t addr, uint8_t *pdata, uint32_t size)
{
    uint32_t page_remain;

    page_remain = 256 - addr%256;

    if(size <= page_remain)
    {
        page_remain = size;
    }
    while(1)
    {
				// 确保写入之前发送 Write Enable 命令
        spi1_flash_write_enable();
			
        spi1_flash_page_write(addr, pdata, page_remain);

        if(size == page_remain)
            break;
        else
        {
            pdata += page_remain;
            addr += page_remain;

            size -= page_remain;
            if(size > 256)
                page_remain = 256;
            else
                page_remain = size;
        }
    }
}
/**
  * @brief 擦除FLASH扇区
  * @param sector_addr 扇区的起始地址
  * @retval None
  */
void spi1_flash_sector_erase(uint32_t sector_addr)
{
    spi1_flash_write_enable();/* 发送FLASH写使能命令 */
    spi1_flash_wait_for_write_end();
		/* 擦除扇区 */
    
    SPI_FLASH_CS_LOW();/* 选择FLASH: CS低电平 */
    spi1_flash_send_byte(W25X_SectorErase);/* 发送扇区擦除指令*/
    spi1_flash_send_byte((sector_addr & 0xFF0000) >> 16);/*发送擦除扇区地址的高位*/
    spi1_flash_send_byte((sector_addr & 0xFF00) >> 8);/* 发送擦除扇区地址的中位 */
    spi1_flash_send_byte(sector_addr & 0xFF); /* 发送擦除扇区地址的低位 */
		/* 停止信号 FLASH: CS 高电平 */
    SPI_FLASH_CS_HIGH();
		/* 等待擦除完毕*/
    spi1_flash_wait_for_write_end();
}

/**
  * @brief 擦除FLASH块
  * @param None
  * @retval None
  */
void spi1_flash_block_erase(void)
{
    spi1_flash_write_enable();

    SPI_FLASH_CS_LOW();
    spi1_flash_send_byte(W25X_ChipErase);
    SPI_FLASH_CS_HIGH();

    spi1_flash_wait_for_write_end();
}
/*进入深度掉电模式*/
void spi1_flash_enter_deep_power_down(void)
{
    SPI_FLASH_CS_LOW(); // 选择FLASH: CS低电平
    spi1_flash_send_byte(W25X_PowerDown); // 发送深度掉电模式指令
    SPI_FLASH_CS_HIGH(); // 停止信号 FLASH: CS 高电平
}
/*退出深度掉电模式*/
void spi1_flash_release_from_deep_power_down(void)
{
    SPI_FLASH_CS_LOW(); // 选择FLASH: CS低电平
    spi1_flash_send_byte(W25X_ReleasePowerDown); // 发送退出深度掉电模式指令
    SPI_FLASH_CS_HIGH(); // 停止信号 FLASH: CS 高电平

    // 释放后需等待一段时间，确保W25Q16完全唤醒
    HAL_Delay(1); // 延时1ms，确保Flash已完全唤醒
}

